/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "DispatchData.h"
#include "QDebug.h"
#include "eMountWin.h"
#include "VolumeGui.h"

#include <assert.h>

//==============================================================================

DispatchData::DispatchData()
{
	// action
	gbDoAskPline = false;
	gbDoJoin = false;
	gbDoShowDialog = false;
	gbDoUpdateVolume = false;
	
	// data
	VolumeDialog::initConfig(gtVolumeDialogConfig);
	gpoPline = 0;
	
	gpoVolumeGui = 0;
}

//==============================================================================

DispatchData::DispatchData(void *p)
{
	// action
	gbDoAskPline = false;
	gbDoJoin = false;
	gbDoShowDialog = false;
	gbDoUpdateVolume = false;
	
	// data
	VolumeDialog::initConfig(gtVolumeDialogConfig);
	gpoPline = 0;
	
	gpoVolumeGui = 0;
	
	gpCaller = p;
}

//==============================================================================

DispatchData::~DispatchData()
{
}

//==============================================================================

bool DispatchData::isReqUserData()
{	
	if (gbDoJoin)
		return true;

	if (gbDoAskPline)
		return true;
	
	if (gbDoShowDialog)
		return true;
			
	if (gbDoUpdateVolume)
		return false;
	
	return true;
}

//==============================================================================

bool DispatchData::process()
{
	if (gbDoJoin)
		m_signal_join();
				
	if (gbDoUpdateVolume)
		m_signal_update_volume();
	
	if (gbDoAskPline)
	{
		assert(gpoPline);
		
		m_signal_pline_askdata(gpoPline);
	}
	
	if (gbDoShowDialog)
	{
		gtVolumeDialogConfig.bWaitData = false;
			
		m_signal_show_dialog(gtVolumeDialogConfig);
	}
	
	return true;
}

//==============================================================================
