/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ENLARGEVOLUMEDIALOG_H
#define ENLARGEVOLUMEDIALOG_H

#include "QDialog.h"
#include "UtilGui.h"

#include <gtkmm.h>

class DialogHelper;
class VolumeConfig;

class EnlargeVolumeDialog : public QDialog
{
public:
	EnlargeVolumeDialog(BaseObjectType* cobject,
						const Glib::RefPtr<Gtk::Builder>& refGlade);
	~EnlargeVolumeDialog();

	void setData(	VolumeConfig *poVolumeConfig,
					unsigned long long *pullNewVolumeSize,
					const unsigned long long ullCurrVolumeSize);
protected:

private:
	UtilGui::tEnlargeVolumeDlg gtEnlargeVolumeDlg;
	DialogHelper *gpoDialogHelper;
	
	// data
	VolumeConfig *gpoVolumeConfig;	
	
	unsigned long long *gpullNewVolumeSize;
	unsigned long long gullCurrVolumeSize;
	
	void onCancel();
	void onEnlarge();
	
	void updateData(const bool bToScreen);
	bool validate();
};
	
#endif /* INITVOLUMEDIALOG_H */
