/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CLONEDATA_H
#define CLONEDATA_H

#include "Data.h"

#include <gtkmm.h>

namespace Pline 
{

class CloneData : public Data
{
public:
	CloneData(const Data &oData);
	virtual ~CloneData();

	CloneData* operator=(const CloneData &oCloneData);
	bool operator==(const CloneData &oCloneData) const;
	bool operator!=(const CloneData &oCloneData) const;
	
	inline const Glib::ustring& getDest() {return gstDest;}
	inline bool getCanOverwrite() {return gbCanOverwrite;}
	
	inline void setDest(const Glib::ustring& st) {gstDest = st;}
	inline void setCanOverwrite(const bool b) {gbCanOverwrite = b;}
	
protected:

private:
	Glib::ustring   gstDest;
	bool			gbCanOverwrite;
	
	void init();
};
	
} // Pline
#endif /* CLONEDATA_H */
