/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CRYPTDATA_H
#define CRYPTDATA_H

#include <gtkmm.h>

#include "Data.h"

namespace Pline
{

class CryptData : public Data
{
public:
	CryptData(const Data &oData);
	virtual ~CryptData();
	
	CryptData* operator=(const CryptData &oCryptData);
	bool operator==(const CryptData &oCryptData) const;
	bool operator!=(const CryptData &oCryptData) const;
	
	inline bool getIsEncrypted() {return gbEncrypted;}
	inline const Glib::ustring& getKeyFile() {return gstKeyFile;}

	inline void setIsEncrypted(const bool b) {gbEncrypted = b;}
	inline void setKeyFile(const Glib::ustring& st) {gstKeyFile = st;}
	
protected:

private:
	bool			gbEncrypted;
	Glib::ustring   gstKeyFile;
	
	void init();
};
	
} // Pline
#endif /* CRYPTDATA_H */
