/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MOUNTBASEFILTER_H
#define MOUNTBASEFILTER_H

#include "Filter.h"

#include <gtkmm.h>

namespace Pline
{

#define MOUNTFILTERBASE_MAXTRY	    5
#define MOUNTFILTERBASE_SLEEP_TRY	500000 // 500 msec

class MountBaseFilter : public Filter
{
public:
	MountBaseFilter();
	virtual ~MountBaseFilter();

	// filter config
	virtual const Glib::ustring getFilterType() {return "Mount";}
	
	// run mode
	typedef enum _RUNMODE_
	{
		kNoRunMode,
		kRunAttach,
		kRunDetach,
		kRunProbe,
	}
	eRunMode;

	inline void setRunMode(eRunMode eRunModeItem) {geRunMode = eRunModeItem;}
	
	// run
	virtual bool isAttached() = 0;
	bool run();
	
	inline eRunMode getLastRunMode() {return geRunModeLast;}
	inline eRunMode getRunMode() {return geRunMode;}
	
protected:
	virtual bool attach() = 0;
	virtual bool detach() = 0;
	virtual bool probe() = 0;
	
private:
	eRunMode geRunMode;
	eRunMode geRunModeLast;
	
};

} // Pline	
#endif /* MOUNTBASEFILTER_H */
