/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef EMOUNTSYS_H
#define EMOUNTSYS_H

#include <gtkmm.h>
#include <vector>

//==============================================================================

class OptionGroup : public Glib::OptionGroup
{
public:
	OptionGroup();

	typedef enum _MODE_
	{
		kNoMode,
		kModeFiles,
		kModeVersion,
		kModeEject,
		kModeList,
		kModeMount,
		kModePing,
		kModeStatus,
	}
	eMode;
	
	eMode getMode(  Glib::ustring *pstDiskLabel,
					std::vector<Glib::ustring> *pvecFile) const;
	
private:
	bool			gbList;
	bool			gbVersion;
	Glib::ustring   gstEject;
	Glib::ustring   gstMount;
	Glib::ustring   gstPing;
	Glib::ustring   gstStatus;
	
	std::vector<Glib::ustring> gvecFile;
	std::vector<Glib::ustring> gvecFile_list;
};

//==============================================================================

class eMountSys
{
public:
	typedef enum _RUNMODE_
	{
		kNoRun,
		kRunSh,
		kRunGui,
	}
	eRunMode;

	eMountSys();
	~eMountSys();

	static eMountSys& getInstance();
	
	inline Glib::RefPtr<Gtk::Builder> getGuiBuilder() {return gpoBuilder;}
	inline eRunMode getRunMode() {return geRunMode;}
	
	void init(int argc, char *argv[], bool *pbRequireKit);
	
	int run(int argc, char *argv[], Gtk::Main *poKit = 0);
	
protected:

private:
	Gtk::Main *gpoKit;
	OptionGroup *gpoOptions;
	Glib::RefPtr<Gtk::Builder> gpoBuilder;

	eRunMode geRunMode;
	OptionGroup::eMode geOptMode;
	Glib::ustring gstDiskLabel;
	std::vector<Glib::ustring> gvecFiles;
	
	int doGui();
	int doShell();
	
	bool parse(int argc, char *argv[]);
};
	
#endif /* EMOUNTSYS_H */
